/* extremely simple interface to PC-KIMMO's recognizer() function */
#include <stdio.h>
#include "pckimmo.h"
#ifdef THINK_C
#include <console.h>
#endif
extern RESULT *recognizer();
int main(argc,argv)
int argc;
char *argv[];
{
LANGUAGE Lang;
RESULT *resp, *rp;
char word[400];		/* 400 should be more than ample... */

#ifdef THINK_C
argc = ccommand(&argv);
#endif

/*
 *  check for plausible command arguments
 */
if (argc != 3)
    {
    fprintf(stderr, "usage: %s rulefile lexfile <input >output\n", argv[0] );
    exit(1);
    }
/*
 *  load the rules file and lexicon file
 */
if (load_rules(argv[1], &Lang, ';') < 0)
    exit(1);
if (load_lexicons(argv[2], &Lang, ';') < 0)
    exit(1);
/*
 *  process the data
 */
while (gets(word) != (char *)NULL)
    {
    resp = recognizer( word, &Lang, 0, 0, (FILE *)NULL);
    for ( rp = resp ; rp ; rp = rp->link )
	{
	if (!isatty(fileno(stdin)))
	    puts(word);
	printf("    %s    %s\n",
			(resp->str)  ? (char *)rp->str  : "",
			(resp->feat) ? (char *)rp->feat : "" );
	}
    if (resp != (RESULT *)NULL)
	free_result(resp);
    else
	printf("    form not recognized\n");
    }
return(0);
}
