/*	USERFUNC.H - function prototypes for PC-KIMMO user interface
 ***************************************************************************
 *	EDIT HISTORY
 *	30-Jan-92	prototypes derived from C source files
 ***************************************************************************
 * Copyright 1992 by the Summer Institute of Linguistics, Inc.
 * All rights reserved.
 */

/*****************************************************************************
 *  Function prototypes
 */


#ifdef __STDC__		/* handle prototypes vs. old-fashioned declarations */
#define P(s) s
#else
#define P(s) ()
#endif

/* pckimmo.c */
int main P((int argc , char **argv ));

/* usercmd.c */
void user_cmd P((void ));

/* userfunc.c */
void start_timing P((void ));
void stop_timing P((void ));
void show_timing P((void ));
#ifdef USE_SIGNAL
#ifdef __STDC__
void sigint_handler P((int sig ));
#else
int sigint_handler P((int sig ));
#endif
#endif
void cgetline P((unsigned char *inLine , int maxLen ));
void printResults P((RESULT *resp , FILE *outfp ));
char *set_filename P((char *filename , char *default_name , char *extension ));
int wanthelp P((char *arg , char *msg ));
void compare_gener P((FILE *cmpfp ));
void compare_recog P((FILE *cmpfp ));
void compare_pairs P((FILE *cmpfp , char *filename ));
void list_pairs P((void ));
void show_rules P((int num ));
void list_rules P((void ));
void set_rules P((char *num , int val ));
void show_status P((void ));
#ifndef THINK_C
void do_system P((unsigned char *cmd ));
#endif
void do_close P((void ));
void do_generate P((unsigned char *form ));
void do_log P((char *filename ));
void do_new P((void ));
void do_recognize P((unsigned char *form ));
void list_lexicon P((void ));
void show_lexicon P((unsigned char *lexname ));
char *strlower P((char *string ));
#ifdef THINK_C
void do_cd P((char *filename ));
#endif
#ifndef THINK_C
void do_edit P((char *filename ));
#endif

#undef P
